-- استيراد الوحدات الضرورية (غير متغير)
require "import"
import "com.androlua.*"
import "android.widget.*"
import "android.content.Context"
import "android.hardware.Sensor"
import "android.hardware.SensorEvent"
import "android.hardware.SensorEventListener"
import "android.hardware.SensorManager"
import "android.os.Handler"

-- تعريف الواجهة الخاصة بك (غير متغير)
layout = {
    LinearLayout,
    orientation = 1,
    layout_width = "fill",
    layout_height = "fill",
    {
        LinearLayout,
        orientation = 0,
        layout_width = -1,
        {
            EditText,
            id = "e",
            InputType = "number",
            hint = "أدخل الزاوية المستهدفة",
            textSize = "18sp",
            textColor = "#FF000000",
            layout_width = "66.7%w",
            layout_height = "20%h",
            background = "#FFFFFFFF",
        },
        {
            Button,
            id = "t",
            text = "بدء",
            textSize = "18sp",
            textColor = "#FF000000",
            layout_width = "25%w",
            layout_height = "20%h",
            background = "#FFFFFFFF",
        },
    },
    {
        Button,  -- Replace ProgressBar with a Close button
        id = "closeButton",  -- Button ID
        text = "إغلاق",  -- Button text
        textSize = "18sp",
        textColor = "#FF000000",
        layout_width = "match_parent",  -- Adjust width
        layout_height = "20%h",
        background = "#FFFFFFFF",
    },
}

dlg = LuaDialog(this)
dlg.title = "تطبيق البوصلة"
dlg.View = loadlayout(layout)
e.setScreenReaderFocusable(true)
e.longClickable = false
z1 = e.getText().toString()
z = tonumber(z1) or 0
local activity = this

-- Initialize sensor manager and sensor
local sensorManager = this.getSystemService(Context.SENSOR_SERVICE)
local compassSensor = sensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION)

-- Define variables to store orientation data
local azimuth = 0

-- Variable to track if the compass service is running
local compassServiceRunning = false

-- Create a sensor event listener
local sensorListener = SensorEventListener {
    onSensorChanged = function(event)
        -- Update azimuth (bearing) from sensor data
        azimuth = event.values[0]

        -- Calculate the difference between the current azimuth and the target angle (112 degrees)
        local angleDifference = (z - azimuth)

        -- Ensure angleDifference is in the range [0, 360)
        if angleDifference < 0 then
            angleDifference = angleDifference + 360
        end

        -- Determine the nearest cardinal direction
        local direction = ""
        if angleDifference < 22.5 then
            direction = "الشرق"
        elseif angleDifference < 67.5 then
            direction = "الشمال الشرقي"
        elseif angleDifference < 112.5 then
            direction = "الشمال"
        elseif angleDifference < 157.5 then
            direction = "الشمال الغربي"
        elseif angleDifference < 202.5 then
            direction = "الغرب"
        elseif angleDifference < 247.5 then
            direction = "الجنوب الغربي"
        elseif angleDifference < 292.5 then
            direction = "الجنوب"
        elseif angleDifference < 337.5 then
            direction = "الجنوب الشرقي"
        else
            direction = "الشرق"
        end

        -- Show a fast and frequent Toast message with the nearest direction and guidance
        local guidance = "اتجه نحو " .. direction .. " للوصول إلى الزاوية المستهدفة."
        Toast.makeText(activity, guidance, Toast.LENGTH_LONG).show()

        -- Calculate progress based on angle difference
        local progress = math.abs((angleDifference / 360) * 100)

        -- Check if the user has reached the target angle
        if progress >= 95 then
            service.beep()
            this.vibrate(true)

            -- Show a fast and frequent Toast message when the target angle is reached
            Toast.makeText(activity, "تم بلوغ الزاوية المستهدفة!", Toast.LENGTH_LONG).show()
        end
    end,

    onAccuracyChanged = function(sensor, accuracy)
        -- Handle accuracy changes if needed
    end
}

-- Set up the click listener for the "Start" button
local buttonStarted = false

t.setOnClickListener(function()
    z1 = e.getText().toString()
    z = tonumber(z1) or 0

    if not buttonStarted then
        -- Register the sensor listener
        sensorManager.registerListener(sensorListener, compassSensor, SensorManager.SENSOR_DELAY_GAME)
        compassServiceRunning = true

        -- Show a fast and frequent Toast message indicating the start of the search
        Toast.makeText(activity, "جاري البحث...", Toast.LENGTH_LONG).show()

        -- Change the button text to "Stop"
        t.setText("إيقاف")

        buttonStarted = true
    else
        -- Unregister the sensor listener
        sensorManager.unregisterListener(sensorListener)

        -- Show a fast and frequent Toast message indicating the end of the search by the user
        Toast.makeText(activity, "تم الإيقاف بواسطة المستخدم.", Toast.LENGTH_LONG).show()

        -- Change the button text back to "Start"
        t.setText("بدء")

        buttonStarted = false
    end
end)

-- Set up the click listener for the "Close" button
closeButton.setOnClickListener(function()
    -- Unregister the sensor listener if it's running
    if compassServiceRunning then
        sensorManager.unregisterListener(sensorListener)
        compassServiceRunning = false
    end

    -- Close the dialog
    dlg.dismiss()
end)

-- Show the dialog
dlg.show()
